% Metro.pro, version 3.0
% 12 February, 2019
% Patent Application #112419 from 1 December, 2016

% Metro.pro, version 1.0 is on the address:
% http://dobrev.com/software/Metro_v1_0.zip

include("metro_map.h"). % try 1, 2, 3
include("metro_data.h").
include("metro_window.h").
include("metro_tools.h").


?-
  initialisation,
  % H is open("test.metro", "rb"),  read_metro(H),  close(H),
  window(title("Metro"), pos(0, 100), size(1900,740), backgr(rgb(0, 200, 200)), paint_indirectly, h_scroll,v_scroll).
  % change_speed.

in_group(0, 3).
in_group(T, 1) :- T > 20, T =< 23.
in_group(50, 3).
in_group(T, 2) :- T > 80, T =< 83.

time_func(end):-
  G_Pause =:= 0,
  start_random_from(G_Time), % make the random deterministic
  (G_Time mod 10 =:= 0, G_WagonNum<G_Wagons_in_use ->
    T:=(G_Time mod time_period)//10,
    (T =:= 0 -> % (time_period/2)
      G_NextColor := (G_NextColor+1) mod 6
    ),
    (in_group(T, Type),  Type>=G_Type->
      G_Number := (G_Number+1) mod 8,
      (G_Type =:= 2, G_Number =:= 1 -> G_Number := 4),
      (G_Type =:= 3, (G_Number =:= 1; G_Number =:= 5) -> G_Number := (G_Number+3) mod 8),
      next_stop(G_Number, Jump, Color1),
      semaphore(8+4):=1,
      wPosoka(G_WagonNum) := 1,
      wagonY(G_WagonNum) := 1250+G_Posoka*250-500, % +500
      (G_WagonNum=:=0 ->
        wPrevious(G_WagonNum) := -1
      else
        wNext(G_WagonNum-1) := G_WagonNum,
        wPrevious(G_WagonNum) := G_WagonNum-1
      ),
      wNext(G_WagonNum) := -1,
      Stop := 0,
      Color2 := (Color1>1 -> G_NextColor+2 else Color1),
      wagon_color(Color2, Color),
      wColor(G_WagonNum) := Color,
      wagonX(G_WagonNum) := -35000,
      wSpeed(G_WagonNum) := G_Posoka*main_speed,
      wTargetSpeed2(G_WagonNum) := G_Posoka*main_speed,
      ((G_Number mod 4)>1 ->
        wagonX(G_WagonNum) := wagonX(G_WagonNum-1)-2000,
        wSpeed(G_WagonNum) := wSpeed(G_WagonNum-1),
        wTargetSpeed(G_WagonNum) := wTargetSpeed(G_WagonNum-1),
        wTargetSpeed2(G_WagonNum) := wTargetSpeed2(G_WagonNum-1),
        wAcceleration(G_WagonNum) := wAcceleration(G_WagonNum-1)
      ),
      %wagonX(G_WagonNum) := 0-20*Number*(5-Speed),
      wNumber(G_WagonNum) := G_Number,
      wJump(G_WagonNum) := Jump,
      wStop(G_WagonNum) := Stop,
      stop_at_pos(G_WagonNum, Stop),
      wFlags(G_WagonNum) := true_value((G_Number mod 4)>1),
      G_WagonNum := G_WagonNum + 1
    )
  ),
  G_Time := G_Time + 1,
  (G_Time mod 600=:=0 -> write("One minute for "+chronometer()/60), nl),
  move_wagons,
  (G_Time mod 10=:=0; G_FastSpeed=:= -1 ->
    set_main_window_text
  ),
  update_window(_).

next_stop(0, 1, 0).
next_stop(1, 1, 2).
next_stop(2, 1, 2).
next_stop(3, 1, 2).
next_stop(4, 2, 1).
next_stop(5, 1, 2).
next_stop(6, 1, 2).
next_stop(7, 1, 2).

move_wagons:-
  for(I, 0, G_WagonNum-1),
  wOldX(I) := wagonX(I),
  (wFlags(I)/\1=:=0, wCount(I)>0->
    (wAcceleration(I) =:=0, G_Unexpected_Delay=:=1->
      Delay := random(frequency_fild),
      (Delay =< 2*unexpected_delay->
        (Delay=:=unexpected_delay->
          % write("Big problem i="+I), nl,
          wCount(I) := wCount(I) + random(1+big_problem)
        else
          wCount(I) := wCount(I) + Delay - unexpected_delay,
          (wCount(I)<1 -> wCount(I):=1)
        )
      )
    ),
    wCount(I) := wCount(I)-1
  else (wAcceleration(I)>0->
    change_speed(I, 1)
  else (wAcceleration(I)<0->
    change_speed(I, -1)
  ))),
  (in_curve(I, X, Y, Sign, R)->
    Alfa := arccos((wagonX(I)-X)/R),
    %write(wagonX(I)+"="+Alfa+"="+cos(Alfa - wSpeed(I)/4625)*4625), nl,
    wagonX(I) := X+cos(Alfa - wSpeed(I)/R)*R,
    wagonY(I) := Y+wPosoka(I)*Sign*(R-sin(Alfa - wSpeed(I)/R)*R)
  else
    wagonX(I) := wagonX(I) + wSpeed(I)
  ),
  % (I=9, wSpeed(I)<200-> write("speed="+wSpeed(I)+" "+G_Time), nl),
  fail.
move_wagons:-
  for(I, 0, G_WagonNum-1),
  NextSpeed := wSpeed(I) + (wPosoka(I)*wAcceleration(I)>0 -> wAcceleration(I) else 0),
  (wFlags(I)/\1=:=0, 2*wPosoka(I)*(wStopAt(I)-wagonX(I)-wSpeed(I)-wAcceleration(I))<NextSpeed**2->
    wFlags(I):=(wFlags(I)\/64)/\0xffce,
    (wPosoka(I)*wSpeed(I)>0->
      Acceleration := -1*wPosoka(I), % 0.5*wSpeed(I)**2/(wagonX(I)-wStopAt(I)),
      wTargetSpeed2(I) := 0,
      move_train(I, Acceleration, 0)
    )
  else (wFlags(I)/\32=\=0->
    (wPrevious(I)=\= -1, wPosoka(I)=:=wPosoka(wPrevious(I))->
      (abs(wSpeed(wPrevious(I)))<abs(wSpeed(I))->
        calc_Distanse(Distanse, Limit, I),
        (2*Distanse<Limit->
          move_train(I, -1*wPosoka(I), 0)
        else (Distanse<Limit->
          move_train(I, -0.5*G_Crazy_Speed*wPosoka(I), 0)
        else (0.8*Distanse>Limit-> % 0.8 coef.
          end_of_slowdown(I)
        else
          move_train(I, 0, 0)
        ))),
        (wFlags(wPrevious(I))/\16=\=0->
          (0.97*Distanse<Limit-> % 0.97 coef.
            (wAcceleration(wPrevious(I))=:=0, abs(wSpeed(wPrevious(I)))<abs(wTargetSpeed2(I))->
              wAcceleration(wPrevious(I)) := wPosoka(I),
              wTargetSpeed(wPrevious(I)) := wTargetSpeed2(I)
            )
          else (abs(wSpeed(I))<abs(wTargetSpeed2(I))->
            move_train(I, wPosoka(I), wTargetSpeed2(I))
          ))
        )
      else (wPosoka(I)*(wagonX(wPrevious(I))-wagonX(I))<wagonSize(I)+wagonSize(wPrevious(I))+G_ExtraDistance+100-> % 100 coef.
        move_train(I, 0, 0)
      %  (wSpeed(wPrevious(I))=:=wSpeed(I), wAcceleration(wPrevious(I)) =:= 0->
      %    wFlags(I):=1
      %  )
      else
        end_of_slowdown(I)
      ))
    else
      end_of_slowdown(I)
    )
  else (wFlags(I)/\7=:=0, wPrevious(I)=\= -1, wPosoka(I)=:=wPosoka(wPrevious(I))->
    calc_Distanse(Distanse, Limit, I),
    (Distanse<Limit->
      wFlags(I):=(wFlags(I)\/32)/\0xffef,
      move_train(I, -0.5*wPosoka(I), 0)
    else (wFlags(I)/\64=\=0->
      wFlags(I):=wFlags(I)/\0xffbf,
      move_train(I, -0.5*wPosoka(I), 0)
    )),
    (0.97*Distanse<Limit, wFlags(wPrevious(I))/\16=\=0, abs(wSpeed(wPrevious(I)))<abs(wTargetSpeed2(I))-> % 0.97 coef.
      wFlags(I):=(wFlags(I)\/32)/\0xffef,
      wAcceleration(wPrevious(I)) := wPosoka(I),
      wTargetSpeed(wPrevious(I)) := wTargetSpeed2(I)
    )
  else (wFlags(I)/\64=\=0->
    wFlags(I):=wFlags(I)/\0xffbf,
    move_train(I, -0.5*wPosoka(I), 0)
  )))),
  fail.
move_wagons:-
  for(I, 0, G_WagonNum-1),
  (wFlags(I)/\1=:=0, wSpeed(I)=:=0, wCount(I)=:=0, wAcceleration(I)=:=0 ->
    %write("i="+I+", "+G_Time+"="+wFlags(I)+"="+wAcceleration(I)), nl,
    (wFlags(I)/\8=\=0->
      return_wagon(I)
    else (wFlags(I)/\4=\=0-> % init_wagon(I)
      close_train(I),
      stop_at_pos(I, 0),
      (finish_point(I)->
        wFlags(I):= 2
      else
        wFlags(I):= 0,
        move_train(I, wPosoka(I), wPosoka(I)*main_speed),
        wTargetSpeed2(I) := wPosoka(I)*main_speed
      )
    else (wFlags(I)/\2=\=0, semaphore(8-4*wPosoka(I))=:=0,
          not(wPrevious(I) =\= -1, wPosoka(I)=:=wPosoka(wPrevious(I)), wPosoka(I)*(wagonX(wPrevious(I))-wagonX(I))>0),
          not(wPosoka(I)=:= -1, G_WagonNum<G_Wagons_in_use)->
      start_wagon(I)
    )))
  ),
  fail.
move_wagons:-
  for(I, 0, G_WagonNum-1),
  where_to_stop(Type, I, N, StationX, Semaphore),
  cross_point(Type, I, N, StationX, Semaphore),
  fail.
move_wagons.

change_speed(I, Sing):-
  (Sing*wTargetSpeed(I)-1>Sing*(wSpeed(I)+wAcceleration(I))->
    wSpeed(I) := wSpeed(I)+wAcceleration(I)
  else
    %write("i="+I+", "+G_Time+"=="+wFlags(I)+"="+wAcceleration(I)), nl,
    (abs(wTargetSpeed(I)-wSpeed(I))-1>abs(wAcceleration(I))-> write("Opposite acceleration! i="+I+" speed=("+wSpeed(I)+","+wTargetSpeed(I)+") Acceleration="+wAcceleration(I)+" now="+G_Time), nl),
    wSpeed(I) := wTargetSpeed(I),
    wAcceleration(I) :=0,
    (wTargetSpeed(I)=:=0 ->
      (wFlags(I)/\8=:=0, abs(wStopAt(I)-wagonX(I))<500 -> % 500 coef.
        (wStop(I)=:=0->
          wFlags(I):=4,
          open_train(I),
          wCount(I):=wait_time+random(1+2*plus_minus)-plus_minus
        else (local_station(wagonX(I), StationX, _), wStopAt(I)=:=4000*wPosoka(I)+StationX->
          stop_at_pos(I, wStop(I)),
          wFlags(I):=2
        ))
      )      
    )
  ).

where_to_stop(Type, I, N, StationX, Semaphore):-
  station(yes, N, StationX, Semaphore, _, _),
  abs(StationX-wagonX(I))<43000,
  stop_point(Type, Point),
  (wPosoka(I)=:=1->
    wOldX(I) =< Point+StationX, Point+StationX< wagonX(I)
  else
    wOldX(I) >= -1*Point+StationX, -1*Point+StationX> wagonX(I)
  ).

stop_point(enter, -8000).
stop_point(switch, -5000).

cross_point(switch, I, N, StationX, _):-
  finish_station(N, I, 1),
  not(wNext(I)=\= -1, wPosoka(I)=:=wPosoka(wNext(I)), wPosoka(I)*(wagonX(I)-wagonX(wNext(I)))>0),
  % (wStop(I)=:=0, wJump(I)>1; wNext(I)=:= -1),
  semaphore(8+4*wPosoka(I)):=0.

cross_point(enter, I, N, StationX, _):-
  % wStop(I) := wStop(I)-1,
  % stop_at_pos(I, wStop(I)),
  wFlags(I):=wFlags(I)/\0xffef,
  (wStop(I)>0, 2*wPosoka(I)*(wStopAt(I)-wagonX(I))>wSpeed(I)**2->
    Speed := main_speed+(wJump(I)>3-> -40 else (wJump(I)<3-> 40 else 10)),
    wTargetSpeed2(I):= wPosoka(I)*Speed,
    (wFlags(I)/\1=:=0->
      (abs(wSpeed(I))<abs(wTargetSpeed2(I)) ->
        move_train(I, wPosoka(I), wTargetSpeed2(I))
      else (abs(wSpeed(I))>abs(wTargetSpeed2(I))->
        move_train(I, -1*wPosoka(I), wTargetSpeed2(I))
      ))
    )
  ).

% Different
% metro_data.h
%  G_ExtraDistance := 2000,
%  G_Type := 1, % 1 is 3-1, 2 is 3-1-1, 3 is 1-1
%  G_Wagons_in_use := 100,
%  G_Number := 3,
% metro_tools.h
%  stop_at_pos
%  return_wagon
% metro_window.h
%  Load 3-1-1

