#!./strawberry

include("banners.pro").

?-
  X is scan(get_environment_arg(0, getenv("QUERY_STRING"))),
  go(X).

go(new):-
  say([[[o,f,f],[f,f,f],[f,f,f]],[[f,f,f],[f,f,f],[f,f,f]],[[f,f,f],[f,f,f],[f,f,f]]], "It's your move.", yes).

go(X):-
  Y is scan(get_environment_arg(1, getenv("QUERY_STRING"))),
  Pos is scan(get_environment_arg(2, getenv("QUERY_STRING"))),
  C is scan(get_environment_arg(3, getenv("QUERY_STRING"))),
  play(X, Y, Pos, C).

play(X1, Y1, Pos, [X, Y]):-
  findZ(X,Y,Z1),
  member3(Pos,f,X1,Y1,Z1),
  !,
  move(Pos2,Pos,x,X1,Y1,Z1),
  Succ is -100,
  (count_successes(member3(Pos2,f,_,_,_))>8 ->
    think(Pos2, Succ, 1);
    think(Pos2, Succ, 2)).
play(X, Y, Pos, C):-
  say(Pos, "Please, click one of the white balls.", yes).

think(Pos, Succ, _):-
   member3(Pos,f,1,1,1),
   move(Pos2,Pos,o,1,1,1),
   say(Pos2, "It's your move.", yes).
think(Pos, Succ, _):-
   not(member3(Pos,f,_,_,_)),
   N1 is count_successes(victory(x,Pos)),
   N2 is count_successes(victory(o,Pos)),
   (N1>N2->say(Pos,"Congratulations! You are the winner.", no);
   (N1=N2->say(Pos,"This game is equal.", no);
   say(Pos,"Sorry but this time you lost.", no))). 
think(Pos, Succ, Deep):-
   move(Pos2,Pos,o),
   Succ2 is 100,
   min_max(Succ2, Pos2, Deep),
   Succ2>Succ,
   Succ:=Succ2,
   set(pos(Pos2)),
   fail. 
think(_, _, _):-
   pos(Pos),
   say(Pos, "It's your move.", yes).
max_min(Succ,Pos,Deep):-
   not(member3(Pos,f,_,_,_)),
   Succ := count_successes(victory(o,Pos)) - count_successes(victory(x,Pos)), !. 
min_max(Succ,Pos,Deep):-
   Deep1 is Deep - 1,
   move(Pos2,Pos,x),
   Succ2 is -100,
   max_min(Succ2, Pos2, Deep1),
   Succ2<Succ,
   Succ:=Succ2,
   fail. 
min_max(_,_,_).  
max_min(Succ,Pos,0):-
   Succ := count_successes(victory(o,Pos)) - count_successes(victory(x,Pos)), !. 
max_min(Succ,Pos,Deep):-
   move(Pos2,Pos,o),
   Succ2 is 100,
   min_max(Succ2, Pos2, Deep),
   Succ2>Succ,
   Succ:=Succ2,
   fail. 
max_min(_,_,_). 

member([El,_,_],El,0).
member([_,El,_],El,1).
member([_,_,El],El,2).

member2(Pos,El,X,Y):-
  	member(Pos,Row,Y),
  	member(Row,El,X).

member3(Pos,El,X,Y,Z):-
  	member(Pos,Page,Z),
  	member(Page,Row,Y),
  	member(Row,El,X).

findZ(X,Y,0):-
        (X- 13)**2 + (Y- 13)**2<144,!.
findZ(X,Y,1):-
        (X- 26)**2 + (Y- 26)**2<144,!.
findZ(X,Y,2):-
        (X- 39)**2 + (Y- 39)**2<144.

replace([El,A,B],[_,A,B],El,0).
replace([A,El,B],[A,_,B],El,1).
replace([A,B,El],[A,B,_],El,2).

move(Pos2,Pos,P,X,Y,Z):-
     member(Pos,Page,Z),
     member(Page,Row,Y),
     replace(Row2, Row,P,X), 
     replace(Page2, Page,Row2,Y),
     replace(Pos2, Pos,Page2,Z).
move(Pos2,Pos,W):-
      member3(Pos,f,X,Y,Z),
      move(Pos2,Pos,W,X,Y,Z).

victory(Who,[[[Who,Who,Who],_,_],_,_]).
victory(Who,[[_,[Who,Who,Who],_],_,_]).
victory(Who,[[_,_,[Who,Who,Who]],_,_]).
victory(Who,[[[Who,_,_],[Who,_,_],[Who,_,_]],_,_]).
victory(Who,[[[_,Who,_],[_,Who,_],[_,Who,_]],_,_]).
victory(Who,[[[_,_,Who],[_,_,Who],[_,_,Who]],_,_]).
victory(Who,[[[Who,_,_],[_,Who,_],[_,_,Who]],_,_]).
victory(Who,[[[_,_,Who],[_,Who,_],[Who,_,_]],_,_]).
victory(Who,[_,[[Who,Who,Who],_,_],_]).
victory(Who,[_,[_,[Who,Who,Who],_],_]).
victory(Who,[_,[_,_,[Who,Who,Who]],_]).
victory(Who,[_,[[Who,_,_],[Who,_,_],[Who,_,_]],_]).
victory(Who,[_,[[_,Who,_],[_,Who,_],[_,Who,_]],_]).
victory(Who,[_,[[_,_,Who],[_,_,Who],[_,_,Who]],_]).
victory(Who,[_,[[Who,_,_],[_,Who,_],[_,_,Who]],_]).
victory(Who,[_,[[_,_,Who],[_,Who,_],[Who,_,_]],_]).
victory(Who,[_,_,[[Who,Who,Who],_,_]]).
victory(Who,[_,_,[_,[Who,Who,Who],_]]).
victory(Who,[_,_,[_,_,[Who,Who,Who]]]).
victory(Who,[_,_,[[Who,_,_],[Who,_,_],[Who,_,_]]]).
victory(Who,[_,_,[[_,Who,_],[_,Who,_],[_,Who,_]]]).
victory(Who,[_,_,[[_,_,Who],[_,_,Who],[_,_,Who]]]).
victory(Who,[_,_,[[Who,_,_],[_,Who,_],[_,_,Who]]]).
victory(Who,[_,_,[[_,_,Who],[_,Who,_],[Who,_,_]]]).
victory(Who,[[[Who,_,_],_,_],[[Who,_,_],_,_],[[Who,_,_],_,_]]).
victory(Who,[[[_,Who,_],_,_],[[_,Who,_],_,_],[[_,Who,_],_,_]]).
victory(Who,[[[_,_,Who],_,_],[[_,_,Who],_,_],[[_,_,Who],_,_]]).
victory(Who,[[_,[Who,_,_],_],[_,[Who,_,_],_],[_,[Who,_,_],_]]).
victory(Who,[[_,[_,Who,_],_],[_,[_,Who,_],_],[_,[_,Who,_],_]]).
victory(Who,[[_,[_,_,Who],_],[_,[_,_,Who],_],[_,[_,_,Who],_]]).
victory(Who,[[_,_,[Who,_,_]],[_,_,[Who,_,_]],[_,_,[Who,_,_]]]).
victory(Who,[[_,_,[_,Who,_]],[_,_,[_,Who,_]],[_,_,[_,Who,_]]]).
victory(Who,[[_,_,[_,_,Who]],[_,_,[_,_,Who]],[_,_,[_,_,Who]]]).
victory(Who,[[[Who,_,_],_,_],[[_,Who,_],_,_],[[_,_,Who],_,_]]).
victory(Who,[[_,[Who,_,_],_],[_,[_,Who,_],_],[_,[_,_,Who],_]]).
victory(Who,[[_,_,[Who,_,_]],[_,_,[_,Who,_]],[_,_,[_,_,Who]]]).
victory(Who,[[[_,_,Who],_,_],[[_,Who,_],_,_],[[Who,_,_],_,_]]).
victory(Who,[[_,[_,_,Who],_],[_,[_,Who,_],_],[_,[Who,_,_],_]]).
victory(Who,[[_,_,[_,_,Who]],[_,_,[_,Who,_]],[_,_,[Who,_,_]]]).
victory(Who,[[[Who,_,_],_,_],[_,[Who,_,_],_],[_,_,[Who,_,_]]]).
victory(Who,[[[_,Who,_],_,_],[_,[_,Who,_],_],[_,_,[_,Who,_]]]).
victory(Who,[[[_,_,Who],_,_],[_,[_,_,Who],_],[_,_,[_,_,Who]]]).
victory(Who,[[_,_,[Who,_,_]],[_,[Who,_,_],_],[[Who,_,_],_,_]]).
victory(Who,[[_,_,[_,Who,_]],[_,[_,Who,_],_],[[_,Who,_],_,_]]).
victory(Who,[[_,_,[_,_,Who]],[_,[_,_,Who],_],[[_,_,Who],_,_]]).
victory(Who,[[[Who,_,_],_,_],[_,[_,Who,_],_],[_,_,[_,_,Who]]]).
victory(Who,[[_,_,[_,_,Who]],[_,[_,Who,_],_],[[Who,_,_],_,_]]).
victory(Who,[[[_,_,Who],_,_],[_,[_,Who,_],_],[_,_,[Who,_,_]]]).
victory(Who,[[_,_,[Who,_,_]],[_,[_,Who,_],_],[[_,_,Who],_,_]]).

say(Pos, Message, Continue):-
  N1 is count_successes(victory(x,Pos)),
  N2 is count_successes(victory(o,Pos)),
  set_content_type("text/html"),
  write("<!doctype html public ""-//w3c//dtd html 4.0 transitional//en"">
<html>
<head>
   <meta http-equiv=""Content-Type"" content=""text/html; charset=windows-1251"">
   <meta name=""Author"" content=""Dimiter Dobrev"">
   <meta name=""GENERATOR"" content=""Mozilla/4.51 [en] (Win98; I) [Netscape]"">
   <title>Tick-Tack-Toe 3x3x3 (Make More Lines)</title>
</head>
  <body text=""#FFFFCC"" bgcolor=""#282848"" link=""#FF0000"" vlink=""#FF9900"" alink=""#FFCC33"">"),

  banner,
  
  write("<br><center><font size=+1>"),   write("You: "),   write(N1),   write(",  The Computer: "),   write(N2),   write("</font></center><br>"),   write("<p>
<center><table BORDER=0 CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH=""1%"" >"),
  for(Y, 0, 2),
  write("
<tr> "),
  for(X, 0, 2),
  write("<td>"),   link(X, Y, Pos, Continue),   write("<img SRC=""/games/Tick-Tack-Toe/"),   member3(Pos, E0, X, Y, 0),   member3(Pos, E1, X, Y, 1),   member3(Pos, E2, X, Y, 2),   write(E0),
  write(E1),
  write(E2),
  write(".gif"" ismap BORDER=0 height=50 width=50></a></td>
"),
  X=2,
  write("</tr>
"),
  Y=2,
  write("
</table></center>

<center>
<p>"),
write("<center><font size=+1>"),
write(Message),
write("</font></center><br><br>"),
write("<a href=""/cgi-bin/Tick-Tack-Toe_More_A.pro?new""><img src=""/games/NewGame_up.gif"" alt=""New Game"" border=0></a>"),
write("<a href=""/games.html""><img src=""/games/BacktoGames_up.gif"" alt=""Back To Games"" border=0></a>"),
write("<a href=""/games/Tick-Tack-Toe/Rules_Make_More.html""><img src=""/games/Rules_up.gif"" alt=""Rules"" border=0></a>"),
write("<a href=""http://www.dobrev.com""><img src=""/games/SP_up.gif"" alt=""Strawberry Prolog"" border=0></a>"),
write("
  <p><b><font color=""#33CCFF""><font size=+3>Tick-Tack-Toe 3x3x3 (Make More Lines)</font></font></b></center>
<p><br><br><br>"),

 banner,

write("
</body>
</html> 
 
"). 
link(X, Y, Pos, yes):- !,   
  write("<a href=""/cgi-bin/Tick-Tack-Toe_More_B.pro?"),   
  write(X),     
  write("&"),     
  write(Y),     
  write("&"),     
  write(Pos),     
  write(""">"). 
link(_, _, _, _). 

